<template>
  <div>
    <div id="stocktable">
      <CModal title="Modal title" size="sm" :show.sync="smallModal">
        {{ SuccessMsg }}
      </CModal>

      <CCardBody>
        <h5>Current Stock</h5>

        <CDataTable
          :items="items"
          :fields="fields"
          table-filter
          items-per-page-select
          :items-per-page="15"
          pagination
          hover
          striped
          border
          
        >
        
        </CDataTable>
        <a
           @click="JSONToCSVConvertor(items,true)" 
          
          class="btn btn-info  btn-sm"
        >
          Export (.xls)
        </a>
        
      </CCardBody>
    </div>
  </div>
  <!-- <div >
  <button  type="button" @click="exportexls"> Export xls</button>&nbsp;
</div> -->
</template>

<script>

const apiurl =  'FGS_FIFO_Daily_Receipt_Transaction/'
const items = [
  { key: "inv_TransId", _style: "" },
  { key: "materialDesc", _style: "" },
  { key: "barcode", _style: "" },
  { key: "suppliername", _style: "" },
  { key: " totalConsumed", _style: "" },
  { key: "batchTypeName", _style: "" },
  { key: "quantity", _style: "" },
  { key: "invoice_No", _style: "" },
  { key: "CurrentStock", _style: "" },
  { key: "invoice_Date", _style: "" },
  { key: "locationName", _style: "" },
  // { key: 'prodDate' ,_style: '', },
  // { key: 'exp_Date' ,_style: '', },
  //  { key: 'entryDate' ,_style: '', },
  //  { key: 'entered_By' , _style: '',},
];

import Vue from "vue";
import axios from "axios";
import VUEAxios from "vue-axios";
Vue.use(VUEAxios, axios);

//const url = $package.url

export default {
  data() {
    return {
      items: items.map((item) => {
        return { ...item };
      }),
      fields: [
        { key: "inv_TransId", label: "Id", _style: "min-width:100px" },
        { key: "materialCode", label: "Code", _style: "min-width:100px" },
        { key: "materialDesc", label: "Material", _style: "min-width:100px" },
        { key: "suppliername", label: "Supplier", _style: "min-width:50px" },
        {
          key: "batchTypeName",
          label: "Batch Type ",
          _style: "min-width:100px",
        },
        { key: "quantity", label: "Supplied Stock", _style: "min-width:50px" },
        {
          key: "currentStock",
          label: "Current Stock",
          _style: "min-width:50px",
        },
        { key: "totalConsumed", label: "Consumed", _style: "min-width:50px" },
        { key: "barcode", label: "Barcode", _style: "min-width:100px" },
        { key: "invoice_Date", label: "Inv.Date", _style: "min-width:50px" },
        { key: "locationName", label: "Location ", _style: "min-width:50px" },
        // { key: 'prodDate' , label: 'Prod Date',_style:'min-width:100px' },
        // { key: 'exp_Date' , label: 'Exp Date',_style:'min-width:100px' },
        // { key: 'entryDate' , label: 'Entry Date',_style:'min-width:100px' },

        //  { key: 'show_details',  label: '',  _style: 'width:12%', }
      ],
      details: [],
      errMsg: "",
    };
  },

  mounted() {
    this.getAllMaterialDetails();
  },

  methods: {
    getAllMaterialDetails() {
      
      Vue.axios
        .get(this.$url + apiurl)
        .then((response) => {
          if (response.data.error) {
            this.errMsg = response.data.message;
          } else {
            this.items = response.data.filter((x) => x.status == 1);
          }
        });
    },

   
 JSONToCSVConvertor(JSONData, ShowLabel) {

  
  //If JSONData is not an object then JSON.parse will parse the JSON string in an Object
  var arrData = typeof JSONData != 'object' ? JSON.parse(JSONData) : JSONData;
   
  var CSV = '';
  //Set Report title in first row or line

  CSV += "Stock Report" + '\r\n\n';

  //This condition will generate the Label/Header
  if (ShowLabel) {
    var row = "";

    //This loop will extract the label from 1st index of on array
 for (var index in arrData[0]) {

if(index == 'inv_TransId'){  index = 'Inv.TransId';}
if(index == 'barcode'){  index = 'Barcode';}
if(index == 'supplier_Id'){  index = 'Supplier Id';}

if(index == 'material_Id'){  index = 'Material Id';}
if(index == 'batch_Type_Id'){  index = 'Batch Type Id';}

if(index == 'quantity'){  index = 'Quantity';}
if(index == 'invoice_No'){  index = 'Inv.No';}

if(index == 'invoice_Date'){  index = 'Inv.Date';}
if(index == 'location_Id'){  index = 'Location Id';}

if(index == 'prodDate'){  index = 'ProdDate';}
if(index == 'exp_Date'){  index = 'Exp Date';}

if(index == 'entryDate'){  index = 'Entry Date';}
if(index == 'entered_By'){  index = 'Entered By';}

if(index == 'status'){  index = 'Status';}
if(index == 'suppliername'){  index = 'Supplier Name';}

if(index == 'materialCode'){  index = 'Material Code';}
if(index == 'materialDesc'){  index = 'Material Desc';}

if(index == 'batchTypeName'){  index = 'Batch Type Name';}
if(index == 'locationName'){  index = 'Location Name';}

if(index == 'currentStock'){  index = 'CurrentStock';}
if(index == 'totalConsumed'){  index = 'TotalConsumed';}
if(index == 'stockRemaining'){  index = 'StockRemaining';}
  //Now convert each value to string and comma-seprated
      row += index + ',';


    }
 
    row = row.slice(0, -1);

    //append Label row with line break
    CSV += row + '\r\n';
 }
 

  //1st loop is to extract each row
  for (var i = 0; i < arrData.length; i++) {
    var row = "";

    //2nd loop will extract each column and convert it in string comma-seprated
    for (var index in arrData[i]) {
      row += '"' + arrData[i][index] + '",';

    }

    row.slice(0, row.length - 1);

    //add a line break after each row
    CSV += row + '\r\n';
   
  }

  if (CSV == '') {
    alert("Invalid data");
    return;
  }
  

  //Generate a file name
  var fileName = "StockReport";
 
  //this will remove the blank-spaces from the title and replace it with an underscore
 //fileName += ReportTitle.replace(/ /g, "_");

 // Initialize file format you want csv or xls
 
var uri = 'data:text/csv;charset=utf-8,' + escape(CSV);

 //var uri = 'data:text/xls;charset=utf-8,' + escape(CSV);


  // Now the little tricky part.
  // you can use either>> window.open(uri);
  // but this will not work in some browsers
  // or you will not get the correct file extension    

  //this trick will generate a temp <a /> tag
  var link = document.createElement("a");
  link.href = uri;
 
  //set the visibility hidden so it will not effect on your web-layout
  link.style = "visibility:hidden";
  link.download = fileName + ".csv";

  //link.download = fileName + ".xls";
 
  //this part will append the anchor tag and remove it after automatic click
  document.body.appendChild(link);
  link.click();
  document.body.removeChild(link);



}
 
  },
};
</script>

